#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"
#include "GL/gl.h"
#include <GL/glx.h>

static int gl__glCreateShader(lua_State *L)
{
  PFNGLCREATESHADERPROC glCreateShader =
      (PFNGLCREATESHADERPROC)glXGetProcAddress("glCreateShader");
  lua_pushnumber(L, glCreateShader(
    luaL_checknumber(L, 1)));
  return 1;
}

static const luaL_Reg functions [] = 
{
  {"glCreateShader", gl__glCreateShader},
  {NULL, NULL}
};

int luaopen_gl(lua_State *L)
{
  lua_newtable(L);
  luaL_register(L, NULL, functions);
  return 1;
}
